VERSION 5.00
Object = "{F9043C88-F6F2-101A-A3C9-08002B2F49FB}#1.2#0"; "Comdlg32.ocx"
Begin VB.Form Form1 
   AutoRedraw      =   -1  'True
   BorderStyle     =   1  'Fixed Single
   Caption         =   "Color Palette Function Demo"
   ClientHeight    =   2790
   ClientLeft      =   45
   ClientTop       =   330
   ClientWidth     =   4050
   LinkTopic       =   "Form1"
   MaxButton       =   0   'False
   ScaleHeight     =   2790
   ScaleWidth      =   4050
   StartUpPosition =   2  'CenterScreen
   Begin MSComDlg.CommonDialog CommonDialog1 
      Left            =   1800
      Top             =   1800
      _ExtentX        =   847
      _ExtentY        =   847
      _Version        =   393216
   End
   Begin VB.CommandButton TEST_Button 
      Caption         =   "TEST"
      Default         =   -1  'True
      Height          =   375
      Left            =   900
      TabIndex        =   2
      Top             =   2340
      Width           =   2175
   End
   Begin VB.TextBox Answer 
      Alignment       =   2  'Center
      BeginProperty Font 
         Name            =   "Arial"
         Size            =   8.25
         Charset         =   0
         Weight          =   700
         Underline       =   0   'False
         Italic          =   0   'False
         Strikethrough   =   0   'False
      EndProperty
      Height          =   315
      Left            =   900
      TabIndex        =   1
      Top             =   1380
      Width           =   2235
   End
   Begin VB.TextBox Ret_Mode 
      Alignment       =   2  'Center
      BeginProperty Font 
         Name            =   "Arial"
         Size            =   8.25
         Charset         =   177
         Weight          =   700
         Underline       =   0   'False
         Italic          =   0   'False
         Strikethrough   =   0   'False
      EndProperty
      Height          =   315
      Left            =   1740
      TabIndex        =   0
      Text            =   "H"
      Top             =   540
      Width           =   555
   End
   Begin VB.Label Label2 
      Alignment       =   2  'Center
      Caption         =   "Selected Color Info Returned"
      Height          =   255
      Left            =   900
      TabIndex        =   4
      Top             =   1140
      Width           =   2235
   End
   Begin VB.Label Label1 
      Alignment       =   2  'Center
      Caption         =   "Color Return Mode ( C,  D  or  H )"
      Height          =   255
      Left            =   780
      TabIndex        =   3
      Top             =   300
      Width           =   2535
   End
End
Attribute VB_Name = "Form1"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
  Option Explicit

  Private Sub TEST_Button_Click()
' This code is executed when the "TEST" button is clicked on.
' It demonstrates the use of a public function that calls the
' common dialog color selection palette.  And returns info on
' which color was selected.
'
' Function written by Jay Tanner in VB5

' Call the color select function
  Answer.Text = Selected_Color(Ret_Mode.Text)

  End Sub

  Private Sub Form_Terminate()
' What to do when this program terminates
  Unload Me
  End Sub

  Public Function Selected_Color(Return_Mode)
' Function to select a color from the common dialog
' color palette.  The information returned can then
' be easily parsed as needed for a specific use.
'
' This function is NOT case sensitive.
'
' THREE return modes are recognized by this function.
' The information returned from this function will be
' in one of these f ormats indicate by the (Return_Mode)
' flag value, which is one of the letters C, D or H,
' where:
' C=Composite - Returns a single decimal value.
' D=RGB values in decimal - Returns 3 decimal integers.
' H=RGB values in hexadecimal - Returns 3 hex integers.
  Dim RetMode As String
  
' Define the composite color value.
' This value is returned from the common dialog palette
' used to select the color.  This value is in the range
' from 0 to 16,777,215 and represents one of the colors
' of the 24 bit palette or a total of 16,777,216 colors
' or 2 to the 24th power,  one color for each different
' 24 bit combination possible,   8 bits for each of the
' red, green and blue color elements.
  Dim C     As Long
  
' Define the separate RGB color component values.
' Each of these is in the range from 0 to 255 and
' represent 8 bits each of the 24 bit composite value.
  Dim R   As Integer ' Red component value   (0 to 255)
  Dim G   As Integer ' Green component value (0 to 255)
  Dim B   As Integer ' Blue component value  (0 to 255)
  
  Dim Out As String  ' Function output string
  
    
' Read indicated C, D or H mode.  If neither D or H is
' found, then C (composite) mode is set by default.
' Only the first character is significant if the flag
' consists of more than one character.
  RetMode = Left(UCase(Trim(Return_Mode)), 1)
  If RetMode <> "D" And RetMode <> "H" Then RetMode = "C"
  
' Setup the color selection palette dialog.
  With CommonDialog1
  
' Set initial flags to open the full palette and allow an
' initial default color selection.
  .Flags = cdlCCFullOpen + cdlCCRGBInit
      
' Set the default selected color when palette is displayed.
' In this test demo, the default select color is silver gray.
' The "cdlCCRGBInit" flag has to be set as shown above for
' the default selection to work.  Otherwise the default color
' selection will be black.
  .Color = RGB(192, 192, 192)
      
' Display the full color palette
  .ShowColor
      
' Get the composite color value C that was selected
' from the palette.
' The composite values allows each individual color in
' the 24 bit spectrum to have a unique index number value
' in the range from 0 to 16,777,215.  In this spectrum,
' the value 0 is black and the value 16,777,215 is white.
' All the other possible colors are in between these
' extreme values.
' This number may be easily decomposed into its individual
' RGB components, and conversely, the RGB values can be used
' to calculate the unique composite color value for that RGB
' combination.
  C = .Color
                      
  End With
 
' Separate the RGB color components from the C value.
' Each RGB component consists of 8 binary bits within
' a 24 bit binary number.  The lowest 8 bits represent
' the value of the color red.  The middle 8 bits are
' the value of the color blue and the highest 8 bits
' are the value of the color green.  This means that
' each of these color elements has 256 possible levels
' of intensity from 0 to 255, the maximum intensity
' level possible for any given RGB component or some
' 256 x 256 x 256 = 16,777,216 possible colors total.
  R = C And 255              ' Get lowest 8 bits  - Red
  G = Int(C / 256) And 255   ' Get middle 8 bits  - Green
  B = Int(C / 65536) And 255 ' Get highest 8 bits - Blue

' Return the color value(s) according to the indicated mode.
' The composite value C is returned by default if the D or H
' return modes are not specifically indicated.

' Set default output to composite color value.
  Out = C

' If D mode is selected, replace default with decimal RGB values.
  If RetMode = "D" Then
     Out = "R=" & R & "    G=" & G & "    B=" & B
  End If
  
' If H mode is selected, replace default with hex RGB values.
  If RetMode = "H" Then
     Out = "R=" & Format(Hex(R), "0#") _
     & "    G=" & Format(Hex(G), "0#") _
     & "    B=" & Format(Hex(B), "0#")
  End If

' At this point, if neither D or H mode was indicated, then
' the C value still remains set as the default output value.

' Now return the value(s) of the selected color as a single
' string of characters.
  Selected_Color = Out

  End Function

